#include<stdio.h>

#define MAXN 1000000
#define MAXM 10000000

int N, M, i, j;
int l[MAXM]; 
int r[MAXM]; //test data
int V[MAXN+1];
int E[2*MAXM];
int sol[MAXN+1]; //reseni
int count[MAXN];
int used[MAXN];

//argument: soubor s testovacimi daty, program cte reseni souteziciho na standardnim vstupu
int main(int argc, char** argv)
{
	FILE *f = fopen(argv[1], "r");
	fscanf(f, "%d%d", &N, &M);
	for (i = 0; i < M; i++)
		fscanf(f, "%d%d", l+i, r+i);
	fclose(f);

	for (i = 0; i < M; i++) {
		V[--l[i]]++;
		V[--r[i]]++;
	}
	for (i = 0; i < N; i++)
		V[i+1] += V[i];
	for (i = 0; i < M; i++) {
		E[--V[l[i]]] = r[i];
		E[--V[r[i]]] = l[i];
	}
	
	i = 0;
	while (scanf("%d", &sol[i]) == 1) {
		if (sol[i] > N || sol[i] < 1) {
			printf("Cislo vrcholu mimo dovoleny rozsah.\n");
			return 1;
		}
		count[--sol[i]]++;
		i++;
		if (i > N) {
			printf("Spatna velikost vystupu.\n");
			return 1;
		}
	}
	if (i < N) {
		printf("Spatna velikost vystupu.\n");
		return 1;
	}
	for (i = 0; i < N; i++) {
		if (count[i] != 1) {
			printf("Reseni neni permutace.\n");
			return 1;
		}
	}
	if (N == 1)
		return 0;
	used[sol[N-1]] = 1;
	for (i = N-2; i >= 0; i--) {
		for (j = V[sol[i]]; j < V[sol[i]+1]; j++) {
			if (used[E[j]]) {
				used[sol[i]] = 1;
			}
		}
		if (!used[sol[i]]) {
			printf("Graf neni vzdy souvisly.\n");
			return 1;
		}
	}
	return 0;
}
